--- old/usr/src/uts/common/fs/smbsrv/smb_common_transact.c	Mon Aug  5 17:26:28 2019
+++ new/usr/src/uts/common/fs/smbsrv/smb_common_transact.c	Mon Aug  5 17:26:28 2019
@@ -21,7 +21,7 @@
 
 /*
  * Copyright (c) 2007, 2010, Oracle and/or its affiliates. All rights reserved.
- * Copyright 2014 Nexenta Systems, Inc.  All rights reserved.
+ * Copyright 2018 Nexenta Systems, Inc.  All rights reserved.
  */
 
 #include <smbsrv/smb_kproto.h>
@@ -30,7 +30,7 @@
 #include <smbsrv/string.h>
 #include <smbsrv/nmpipes.h>
 #include <smbsrv/mailslot.h>
-#include <smbsrv/winioctl.h>
+#include <smb/winioctl.h>
 
 /*
  * count of bytes in server response packet
@@ -55,7 +55,7 @@
 smb_sdrc_t
 smb_pre_transaction(smb_request_t *sr)
 {
-	DTRACE_SMB_1(op__Transaction__start, smb_request_t *, sr);
+	DTRACE_SMB_START(op__Transaction, smb_request_t *, sr);
 	return (SDRC_SUCCESS);
 }
 
@@ -62,7 +62,7 @@
 void
 smb_post_transaction(smb_request_t *sr)
 {
-	DTRACE_SMB_1(op__Transaction__done, smb_request_t *, sr);
+	DTRACE_SMB_DONE(op__Transaction, smb_request_t *, sr);
 }
 
 smb_sdrc_t
@@ -156,7 +156,7 @@
 smb_sdrc_t
 smb_pre_transaction_secondary(smb_request_t *sr)
 {
-	DTRACE_SMB_1(op__TransactionSecondary__start, smb_request_t *, sr);
+	DTRACE_SMB_START(op__TransactionSecondary, smb_request_t *, sr);
 	return (SDRC_SUCCESS);
 }
 
@@ -163,7 +163,7 @@
 void
 smb_post_transaction_secondary(smb_request_t *sr)
 {
-	DTRACE_SMB_1(op__TransactionSecondary__done, smb_request_t *, sr);
+	DTRACE_SMB_DONE(op__TransactionSecondary, smb_request_t *, sr);
 }
 
 smb_sdrc_t
@@ -254,7 +254,7 @@
 smb_sdrc_t
 smb_pre_ioctl(smb_request_t *sr)
 {
-	DTRACE_SMB_1(op__Ioctl__start, smb_request_t *, sr);
+	DTRACE_SMB_START(op__Ioctl, smb_request_t *, sr);
 	return (SDRC_SUCCESS);
 }
 
@@ -261,7 +261,7 @@
 void
 smb_post_ioctl(smb_request_t *sr)
 {
-	DTRACE_SMB_1(op__Ioctl__done, smb_request_t *, sr);
+	DTRACE_SMB_DONE(op__Ioctl, smb_request_t *, sr);
 }
 
 smb_sdrc_t
@@ -285,7 +285,7 @@
 smb_sdrc_t
 smb_pre_transaction2(smb_request_t *sr)
 {
-	DTRACE_SMB_1(op__Transaction2__start, smb_request_t *, sr);
+	DTRACE_SMB_START(op__Transaction2, smb_request_t *, sr);
 	return (SDRC_SUCCESS);
 }
 
@@ -292,7 +292,7 @@
 void
 smb_post_transaction2(smb_request_t *sr)
 {
-	DTRACE_SMB_1(op__Transaction2__done, smb_request_t *, sr);
+	DTRACE_SMB_DONE(op__Transaction2, smb_request_t *, sr);
 }
 
 smb_sdrc_t
@@ -368,7 +368,7 @@
 smb_sdrc_t
 smb_pre_transaction2_secondary(smb_request_t *sr)
 {
-	DTRACE_SMB_1(op__Transaction2Secondary__start, smb_request_t *, sr);
+	DTRACE_SMB_START(op__Transaction2Secondary, smb_request_t *, sr);
 	return (SDRC_SUCCESS);
 }
 
@@ -375,7 +375,7 @@
 void
 smb_post_transaction2_secondary(smb_request_t *sr)
 {
-	DTRACE_SMB_1(op__Transaction2Secondary__done, smb_request_t *, sr);
+	DTRACE_SMB_DONE(op__Transaction2Secondary, smb_request_t *, sr);
 }
 
 smb_sdrc_t
@@ -558,7 +558,7 @@
 smb_sdrc_t
 smb_pre_nt_transact(smb_request_t *sr)
 {
-	DTRACE_SMB_1(op__NtTransact__start, smb_request_t *, sr);
+	DTRACE_SMB_START(op__NtTransact, smb_request_t *, sr);
 	return (SDRC_SUCCESS);
 }
 
@@ -565,7 +565,7 @@
 void
 smb_post_nt_transact(smb_request_t *sr)
 {
-	DTRACE_SMB_1(op__NtTransact__done, smb_request_t *, sr);
+	DTRACE_SMB_DONE(op__NtTransact, smb_request_t *, sr);
 }
 
 smb_sdrc_t
@@ -644,7 +644,7 @@
 smb_sdrc_t
 smb_pre_nt_transact_secondary(smb_request_t *sr)
 {
-	DTRACE_SMB_1(op__NtTransactSecondary__start, smb_request_t *, sr);
+	DTRACE_SMB_START(op__NtTransactSecondary, smb_request_t *, sr);
 	return (SDRC_SUCCESS);
 }
 
@@ -651,7 +651,7 @@
 void
 smb_post_nt_transact_secondary(smb_request_t *sr)
 {
-	DTRACE_SMB_1(op__NtTransactSecondary__done, smb_request_t *, sr);
+	DTRACE_SMB_DONE(op__NtTransactSecondary, smb_request_t *, sr);
 }
 
 smb_sdrc_t
@@ -1432,7 +1432,7 @@
 	fsctl.in_mbc = &xa->req_data_mb; /* write from here */
 	fsctl.out_mbc = &xa->rep_data_mb; /* read into here */
 
-	status = smb_opipe_fsctl(sr, &fsctl);
+	status = smb_opipe_transceive(sr, &fsctl);
 	if (status) {
 		smbsr_status(sr, status, 0, 0);
 		if (NT_SC_SEVERITY(status) == NT_STATUS_SEVERITY_ERROR)
@@ -1763,7 +1763,7 @@
 		/* Param off from hdr start */
 		data_off = param_off + n_param + data_pad;
 		fmt = "bww2.wwwwwwb.Cw#.C#.C";
-		nt_unknown_secret = data_pad;
+		nt_unknown_secret = (uint16_t)data_pad;
 	}
 
 	total_bytes = param_pad + n_param + data_pad + n_data;